import bpy.types
from ..utils.pref_utils import get_keyops_prefs

def remove_confirm_delete():
    prefs = get_keyops_prefs()

    if not prefs.auto_delete_confirm_object_mode:
        # wm = bpy.context.window_manager
        # km = wm.keyconfigs.active.keymaps['Object Mode']                    
        # km.keymap_items.new('object.delete', 'X', 'PRESS').properties.confirm = False
        
        #this does not work since the keymap is not aviable at startup
        for keymap in bpy.context.window_manager.keyconfigs.user.keymaps:
            if keymap.name == 'Object Mode':
                for keymap_item in keymap.keymap_items:
                    if keymap_item.name == "Delete" and keymap_item.type == "X":
                        if keymap_item.properties.confirm == True:
                            keymap_item.properties.confirm = False
        # for keymap in bpy.context.window_manager.keyconfigs.user.keymaps:
        #     if keymap.name == 'Object Mode':
        #         for keymap_item in keymap.keymap_items:
        #             if keymap_item.name == "Delete" and keymap_item.type == "X":
        #                 if keymap_item.properties.use_global == True:
        #                     keymap_item.properties.use_global = True
        #                     print("delete")
        
def default_confirm_delete():   
    for keymap in bpy.context.window_manager.keyconfigs.user.keymaps:
        if keymap.name == 'Object Mode':
            for keymap_item in keymap.keymap_items:
                if keymap_item.name == "Delete" and keymap_item.type == "X":
                    if keymap_item.properties.confirm == False:
                        keymap_item.properties.confirm = True

def update_auto_delete_confirm_delete(self, context):
    if self.auto_delete_confirm_object_mode:
        default_confirm_delete()
    else:
        remove_confirm_delete()

class AutoDelete(bpy.types.Operator):
    bl_idname = "keyops.auto_delete"
    bl_label = "KeyOps: Auto Delete"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return context.active_object.mode == 'EDIT'

    def execute(self, context):
        prefs = get_keyops_prefs()
        select_mode = context.tool_settings.mesh_select_mode
        if select_mode[0]:
            bpy.ops.mesh.delete(type='VERT')
        elif select_mode[1]:
            if prefs.auto_delete_dissolv_edge:
                bpy.ops.mesh.dissolve_edges()
            else:
                bpy.ops.mesh.delete(type='EDGE')
        elif select_mode[2]:
            bpy.ops.mesh.delete(type='FACE')
        else:
            self.report({'ERROR'}, "Invalid selection mode")

        return {'FINISHED'}
    
    def register():
        remove_confirm_delete()
    
    def unregister():
        default_confirm_delete()
