import bpy.types
from ..utils.pref_utils import get_keyops_prefs

previuse_gizmo_translate_state = False
        
class PivotPress(bpy.types.Operator):
    bl_idname = "keyops.pivot_press"
    bl_label = "KeyOps: Pivot Press"
    bl_description = "Move Pivot Key Press"
    bl_options = {'REGISTER', 'PRESET'}

    type: bpy.props.StringProperty(default="") # type: ignore

    @classmethod
    def poll(cls, context):
        return context.active_object is not None and context.active_object.mode == 'OBJECT'
    
    def execute(self, context):
        prefs =  get_keyops_prefs()
        pivot_behavior = prefs.maya_pivot_behavior
        show_gizmo = prefs.maya_pivot_show_gizmo

        global previuse_gizmo_translate_state

        if self.type == 'PivotPress':
            if not context.scene.tool_settings.use_transform_data_origin:
                if bpy.context.space_data.show_gizmo_object_translate:
                    previuse_gizmo_translate_state = True
                else:
                    previuse_gizmo_translate_state = False

            if pivot_behavior == 'TOGGLE':
                if context.scene.tool_settings.use_transform_data_origin:
                     bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state

                context.scene.tool_settings.use_transform_data_origin = not context.scene.tool_settings.use_transform_data_origin
               
                if show_gizmo and context.scene.tool_settings.use_transform_data_origin:
                    bpy.context.space_data.show_gizmo_context = True
                    bpy.context.space_data.show_gizmo_object_translate = True
                else:
                    bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state
               
            else:
                context.scene.tool_settings.use_transform_data_origin = True
                if show_gizmo and bpy.context.space_data.show_gizmo_object_translate == False:
                    bpy.context.space_data.show_gizmo_context = True
                    bpy.context.space_data.show_gizmo_object_translate = True
                   
        elif self.type == 'PivotRelease':
            if pivot_behavior == 'HOLD':
                context.scene.tool_settings.use_transform_data_origin = False
                if show_gizmo:
                     bpy.context.space_data.show_gizmo_object_translate = previuse_gizmo_translate_state

        return {'FINISHED'}

 